unit Options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TAPILine;

type
  TformOptions = class(TForm)
    SelectedLine: TComboBox;
    Label1: TLabel;
    PhoneNumber: TEdit;
    Label2: TLabel;
    DevDirectAccess: TCheckBox;
    Script: TMemo;
    LogFile: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    WaitForC: TCheckBox;
    Image1: TImage;
    eRings: TEdit;
    Label3: TLabel;
    rgCallType: TRadioGroup;
    procedure DevDirectAccessClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formOptions: TformOptions;

implementation

uses tl_test;

{$R *.DFM}

procedure TformOptions.DevDirectAccessClick(Sender: TObject);
begin
    if DevDirectAccess.Checked then
       Begin
       Script.Enabled := True;
       LogFile.Enabled := True;
       End
    else
       Begin
       Script.Enabled := False;
       LogFile.Enabled := False;
       End
end;

procedure TformOptions.Button2Click(Sender: TObject);
begin
    with formMain.TAPILine1 do
         Begin
         DevIDToInitialize := SelectedLine.ItemIndex;
         PhoneNumber := self.PhoneNumber.Text;
         DeviceDirectAccess := DevDirectAccess.Checked;
         WaitForCall := WaitForC.Checked;
         DirectAccessLogFile := LogFile.Text;
         RingsCount := StrToInt (eRings.Text);
         if rgCallType.ItemIndex = 1 Then
            CallType := ctDataModemCall
         else
            CallType := ctSimpleCall;

         if DeviceDirectAccess Then
            Begin
            DirectAccessScript.Clear;
            DirectAccessScript.Assign (Script.Lines);
            End;
         End;

end;

procedure TformOptions.FormActivate(Sender: TObject);
begin
    with formMain.TAPILine1 do
         Begin
         SelectedLine.ItemIndex := DevIDToInitialize;
         self.PhoneNumber.Text := PhoneNumber;
         self.DevDirectAccess.Checked := DeviceDirectAccess;
         self.WaitForC.Checked := WaitForCall;
         self.LogFile.Text := DirectAccessLogFile;
         End;

    Script.Clear;
    Script.Lines.Assign (formMain.TAPILine1.DirectAccessScript);

    if formMain.TAPILine1.DevIDToInitialize <> -1 Then
        Image1.Picture.Icon.handle := formMain.TAPILine1.GetIcon (formMain.TAPILine1.DevIDToInitialize);
end;

procedure TformOptions.FormCreate(Sender: TObject);
begin
    formMain.TAPILine1.FillTAPILine (SelectedLine.Items);
end;

end.
