unit tl_test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, TAPILine, StdCtrls, ExtCtrls, Buttons;

type
  TformMain = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Modem1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Howtodial1: TMenuItem;
    Configuration1: TMenuItem;
    N1: TMenuItem;
    Connect1: TMenuItem;
    N2: TMenuItem;
    Disconnect1: TMenuItem;
    Memo1: TMemo;
    Panel1: TPanel;
    toWrite: TEdit;
    N3: TMenuItem;
    Sendfile1: TMenuItem;
    OpenDialog: TOpenDialog;
    Receivefile1: TMenuItem;
    SaveDialog1: TSaveDialog;
    TAPILine1: TTAPILine;
    Panel2: TPanel;
    sbDial: TSpeedButton;
    sbDisconnect: TSpeedButton;
    sbSendFile: TSpeedButton;
    sbReceiveFile: TSpeedButton;
    sbStop: TSpeedButton;
    sbResume: TSpeedButton;
    SpeedButton7: TSpeedButton;
    N4: TMenuItem;
    StopOnNewDataEvent1: TMenuItem;
    ResumeOnNewDataevent1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Howtodial1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TAPILine1Connection(Sender: TObject);
    procedure Configuration1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure toWriteEnter(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure OnDissconectClick(Sender: TObject);
    procedure toWriteKeyPress(Sender: TObject; var Key: Char);
    procedure Sendfile1Click(Sender: TObject);
    procedure Receivefile1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TAPILine1DropCall(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure TAPILine1NewData(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TAPILine1CallerID(Sender: TObject; ID, IDName: String);
    procedure TAPILine1Close(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMain: TformMain;

implementation

uses Options, About;

{$R *.DFM}

procedure TformMain.Exit1Click(Sender: TObject);
begin
    Close;
end;

procedure TformMain.Options1Click(Sender: TObject);
begin
    if formOptions = nil Then
       formOptions := TformOptions.Create (self);
    formOptions.ShowModal;
    Connect1.Enabled := True;
    try
       TAPILine1.Open;
    except
        on Exception do ShowMessage ('Line isn''t properly configurated!');
    end;
end;

procedure TformMain.Howtodial1Click(Sender: TObject);
begin
    TAPILine1.TranslateDialog;
end;

procedure TformMain.FormCreate(Sender: TObject);
begin
    TAPILine1.InfoLabel := StatusBar1.Panels[0];
    TAPILine1.ClockLabel := StatusBar1.Panels[1];
    Options1Click (nil);
    TAPILine1.TraceMemo:=Memo1;
end;

procedure TformMain.TAPILine1Connection(Sender: TObject);
begin
    if TAPILine1.CallType = ctSimpleCall then
       Begin
       ShowMessage ('We are waiting when remote human picks up receive!');
       formDialing.Show;
       end
    else
       Begin
       ShowMessage ('Connected!');

       Disconnect1.Enabled := True;
       Connect1.Enabled := False;
       Sendfile1.Enabled := True;
       Receivefile1.Enabled := True;
       StopOnNewDataEvent1.Enabled := True;
       ResumeOnNewDataevent1.Enabled := True;

       sbDisconnect.Enabled := True;
       sbDial.Enabled := False;
       sbSendfile.Enabled := True;
       sbReceivefile.Enabled := True;
       sbStop.Enabled := True;
       sbResume.Enabled := True;
       End;
end;

procedure TformMain.Configuration1Click(Sender: TObject);
begin
    TAPILine1.ConfigDialog;
end;

procedure TformMain.Connect1Click(Sender: TObject);
begin
    TAPILine1.MakeCall;
end;

procedure TformMain.Disconnect1Click(Sender: TObject);
begin
    TAPILine1.Drop;

    Disconnect1.Enabled := False;
    Connect1.Enabled := True;
    Sendfile1.Enabled := False;
    Receivefile1.Enabled := False;
    ResumeOnNewDataevent1.Enabled := False;
    StopOnNewDataEvent1.Enabled := False;

    sbDisconnect.Enabled := False;
    sbDial.Enabled := True;
    sbSendfile.Enabled := False;
    sbReceivefile.Enabled := False;
    sbStop.Enabled := False;
    sbResume.Enabled := False;
end;

procedure TformMain.toWriteEnter(Sender: TObject);
begin
    TAPILine1.Write (toWrite.Text);
    toWrite.Text := '';
end;

procedure TformMain.Memo1DblClick(Sender: TObject);
begin
    Memo1.Lines.Add (TAPILine1.Read (0));
end;

procedure TformMain.OnDissconectClick(Sender: TObject);
begin
    Disconnect1.Enabled := False;
    Connect1.Enabled := True;
end;

procedure TformMain.toWriteKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = Chr (13) then
       Begin
       toWriteEnter (nil);
       key := Chr(0);
       End;

end;

procedure TformMain.Sendfile1Click(Sender: TObject);
Var
  F: file of byte;
  S: string;
  Buf: array[0..2049] of Char;
  NumRead, size: longint;
  timeToWrite, beforeWriting, afterWriting : DWORD;
  sFile, sResponse: string;
  len, i: integer;
begin
    if OpenDialog.Execute then          { Display Open dialog box }
       begin
       AssignFile(F, OpenDialog.FileName);   { File selected in dialog box }
       Reset(F);
       size := FileSize(F);
       timeToWrite := 0;
       sFile := Copy (ExtractFileName (OpenDialog.FileName), 1, 12);

       sResponse := 'sendFILE:'+sFile;
       len := Length (sResponse);
       for i := len to 20 do sResponse := sResponse + ' ';
       TAPILine1.Write (sResponse+NEW_LINE); //23

       sResponse := TAPILine1.Read (22);
       if (sResponse <> 'sendFILE:OK         '+NEW_LINE) Then
          ShowMessage (sResponse + ' - bad SendFile response.');
       size := 0;

       while True do
            Begin
            BlockRead (F, Buf, 2048, NumRead);

            if NumRead = 0 Then
               Break;

            sResponse := 'FILELeng:'+IntToStr (NumRead);
            len := Length (sResponse);
            for i := len to 19 do sResponse := sResponse + ' ';
            if (Length (sResponse) <> 20) Then ShowMessage ('Bad length');
            TAPILine1.Write (sResponse+NEW_LINE); //22

            buf[NumRead] := Chr (0);

            if TAPILine1.WriteLargeData (@buf, NumRead) = False Then ShowMessage ('Write failed');

            size := size + NumRead;
            StatusBar1.Panels[0].text := 'Bytes has been written: '+IntToStr (size);
            Application.ProcessMessages;

            sResponse := TAPILine1.Read (22);
            if (sResponse <> 'FILELeng:OK         '+NEW_LINE) Then
               ShowMessage (sResponse + ' - bad File Length response.');
            End;

       CloseFile (F);
//       StatusBar1.Panels[0].text := 'Bytes has been written: '+IntToStr (size);
       End;
end;

procedure TformMain.Receivefile1Click(Sender: TObject);
Var
  Buf: array[0..2049] of Char;
  F: file of byte;
  timeToWrite, beforeWriting, afterWriting : DWORD;
  size, len:  longint;
  sResponse, FileName, strBlockLen: string;
begin

       sResponse := TAPILine1.Read (23); //23
       FileName := Copy (sResponse, pos (':', sResponse)+1, pos ('.', sResponse)-pos (':', sResponse)-1);
       TAPILine1.Write ('sendFILE:OK         '+NEW_LINE);

       AssignFile (F, FileName+'.sav');   { File selected in dialog box }
       Rewrite(F);
       timeToWrite := 0;
       size := 0;

       While True do
           Begin
           sResponse := TAPILine1.Read (22); //22
           strBlockLen := Copy (sResponse, pos (':', sResponse)+1, pos (' ', sResponse)-pos (':', sResponse));
           len := StrToInt (Trim (strBlockLen));

           beforeWriting := GetTickCount;
           TAPILine1.ReadLargeData (@buf, len);
           afterWriting := GetTickCount;

           Inc (timeToWrite, afterWriting-beforeWriting);
           Inc (size, len);
           BlockWrite (F, Buf, len);

           TAPILine1.Write ('FILELeng:OK         '+NEW_LINE);
           if len <> 2048 Then break;

           StatusBar1.Panels[0].text := 'Bytes has been read: '+IntToStr (size)+ '  Time elapsed: '+IntToStr (timeToWrite)+' ml.sec.';
           Application.ProcessMessages;
           End;

       size := FileSize(F);
       CloseFile (F);
       StatusBar1.Panels[0].text := 'Bytes has been read: '+IntToStr (size)+ '  Time elapsed: '+IntToStr (timeToWrite)+' ml.sec.';
end;

procedure TformMain.FormDestroy(Sender: TObject);
begin
    TAPILine1.free;
end;

procedure TformMain.TAPILine1DropCall(Sender: TObject);
begin
    TAPILine1.Close;
end;

procedure TformMain.About1Click(Sender: TObject);
begin
    AboutBox := TAboutBox.Create (self);
    AboutBox.ShowModal;
    AboutBox.Free;
end;

procedure TformMain.TAPILine1NewData(Sender: TObject);
begin
    ShowMessage ('New data arrives in COM port!');
    Memo1DblClick(nil);
end;

procedure TformMain.SpeedButton1Click(Sender: TObject);
begin
    TAPILine1.bStopWaitingNewData := not TAPILine1.bStopWaitingNewData;
end;

procedure TformMain.Button1Click(Sender: TObject);
begin
    TAPILine1.ResumeWaitingNewData;
end;

procedure TformMain.TAPILine1CallerID(Sender: TObject; ID, IDName: String);
begin
    ShowMessage('Call!');    
    StatusBar1.Panels[2].Text:=IDNAme+', '+ID;
end;

procedure TformMain.TAPILine1Close(Sender: TObject);
begin
    TAPILine1.Open;
end;

end.
